

# include <stdlib.h>
# include <stdio.h>

#define MAX_LEN 255


void execute (int n, int w[]);
int read_file(int *w, char *file_name, int *n);
void copy_array ( int n, int a1[], int a2[] );
int *copy_new_array ( int n, int a1[] );
int get_group_sum ( int n, int x[], int y[] );
int get_sum ( int n, int a[] );
void group_divide ( int n, int w[], int c[], int *difference );
void next_variation ( int n, int t[], int *rank );

int counter = 0;

int main () {
    int n = 0;
    int *w;
    int w1[MAX_LEN];
    char file_name[MAX_LEN];

    printf ("Iveskite failo pavadinima: ");
    scanf ("%s", file_name);
    if (read_file (w1, file_name, &n) == 1){
        printf ("Klaida: Failas neegzistuoja");
        exit(0);
    }
    w = copy_new_array (n, w1);
    execute (n, w);
    free (w);
    printf ("%d", counter);
    exit(0);
}

void execute ( int n, int w[] ) {
    int *c;
    int difference;
    int i;
    int w0_sum = 0;
    int w1_sum = 0;
    c = ( int * ) malloc ( n * sizeof ( int ) );


    printf ("Ivesti nariai: \n");
    for ( i = 0; i < n; i++) {
        printf("%4d.   %d\n", i, w[i]);
    }

    group_divide ( n, w, c, &difference );

    printf ("\nIvykdytas grupavimas. Gauti rezultatai: \n");

    printf("*Pirmosios grupes nariai: \n");
    for (i = 0; i < n; i++) {
        if (c[i] == 0) {
            printf ("%4d.   %d\n", i, w[i]);
            w0_sum += w[i];
        }
    }
    printf (" ----------\n");
    printf ("Suma: %3d \n\n", w0_sum);

    printf("*Antrosios grupes nariai: \n");
    for (i = 0; i < n; i++) {
        if (c[i] == 1) {
            printf ("%4d.   %d\n", i, w[i]);
            w1_sum += w[i];
        }
    }
    printf (" ----------\n");
    printf ("Suma: %3d \n\n", w1_sum);
    printf ("Sumu skirtumas = %4d\n", difference);

    free (c);
    return;
}

int read_file(int *w, char *file_name, int *n) {
    FILE *fr;
    int value, i = 0;

    if ((fr = fopen (file_name, "r")) == NULL)
        return 1;
    while (!feof (fr) && fscanf (fr, "%d", &value) && i < MAX_LEN) {
        w[i] = value;
        *n += 1;
        i++;
    }
    fclose (fr);
    return(0);
}

void copy_array (int n, int a1[], int a2[]) {
    int i;
    for (i = 0; i < n; i++)
        a2[i] = a1[i];
    return;
}

int *copy_new_array (int n, int a1[]) {
    int *a2, i;

    a2 = (int*) malloc (n * sizeof(int));
    for (i = 0; i < n; i++)
        a2[i] = a1[i];
    return a2;
}

int get_group_sum (int n, int x[], int y[]) {
    int i, value = 0;

    for (i = 0; i < n; i++){
        value = value + x[i] * y[i];}
    return value;
}

int get_sum (int n, int a[]) {
    int i, sum;
    sum = 0;

    for (i = 0; i < n; i++)
        sum = sum + a[i];
    return sum;
}

void group_divide (int n, int w[], int c[], int *min_diff) {
    int *d;
    int tmp_diff, w_sum, rank;
    w_sum = get_sum (n, w);
    *min_diff = w_sum;
    rank = -1;
    d = (int *) malloc (n * sizeof(int));

    while (1)
    {

        next_variation (n, d, &rank);

        if (rank == -1)
            break;

        tmp_diff = abs ((w_sum - 2 * get_group_sum (n, d, w)));
        if (tmp_diff < *min_diff)
        {
            *min_diff = tmp_diff;
            copy_array (n, d, c);
        }
        //if (*min_diff == 0)
        //break;
        counter++;
    }
    free (d);
    return;
}

void next_variation (int n, int t[], int *rank) {
    int i;

    if (*rank == -1)
    {
        for (i = 0; i < n; i++)
            t[i] = 0;
        *rank = 0;
        return;
    }

    for (i = n - 1; 0 <= i; i--)
    {
        if (t[i] == 0)
        {
            t[i] = 1;
            *rank = *rank + 1;
           return;
        }
        else t[i] = 0;
    }
    *rank = -1;
    return;
}
